#ifndef POP3_H
#define POP3_H

/*
 * autor 
 * Micha Podsiadlik
 * michal at gov.one.pl
 */

#include <qobject.h>
#include <qstring.h>

#include "ssocket.h"

class Pop3Proto: public QObject
{
	Q_OBJECT

		SSocket *mailserver;
		enum State {
			None,
			Connecting,
			LoginUser,
			LoginPassword,
			Stat,
			Quit
		} state;
		void writesocket(QString* str);
		QString Name, Host, User, Password;
		int Port, Lastmails;
		SecureType Encryption;
	public:	
		Pop3Proto(QString name, QString host, int port, QString user, QString password, SecureType type=WithoutEncryption);
		~Pop3Proto();
		void setName(QString name) { Name=name; };
		void setHost(QString host) { Host=host; };
		void setPort(int port) { Port=port; };
		void setUser(QString user) { User=user; };
		void setPassword(QString password) { Password=password; };
		void setLastmails(int lastmails) { Lastmails=lastmails; };
		void setEncryption(SecureType type);
		QString getName() { return Name; };
		QString getHost() { return Host; };
		int getPort() { return Port; };
		QString getUser() { return User; };
		QString getPassword() { return Password; };
		int getLastmails() { return Lastmails; };
		void getStats();
		SecureType getEncryption() { return Encryption; };
	public slots:
		void connecterror(int error);
		void connected();
		void parsemessage();
	signals:
		void done(int last, int total, int size, QString name);
		
};

#endif

